Index: codes/icosagcm/trunk/src/transfert_mpi.f90
===================================================================
--- codes/icosagcm/trunk/src/transfert_mpi.f90	(revision 185)
+++ codes/icosagcm/trunk/src/transfert_mpi.f90	(revision 186)
@@ -1106,157 +1081,306 @@
     INTEGER :: irecv,isend
     INTEGER :: ireq,nreq
-    INTEGER :: ind,n,l,m
-    INTEGER :: dim3,dim4
+    INTEGER :: ind,i,n,l,m
+    INTEGER :: dim3,dim4,d3,d4
+    INTEGER,POINTER :: src_value(:)
+    INTEGER,POINTER :: sign(:)
+    INTEGER :: offset,msize,rank
+
+    CALL trace_start("transfert_mpi")
 
 !$OMP BARRIER
 
-    CALL trace_start("transfert_mpi")
-
-    IF (.NOT. message%pending) RETURN
-    
-    field=>message%field
-    nreq=message%nreq
-    
+
+!$OMP MASTER
+    message%field=>field
+
+    IF (message%nreq>0) THEN
+      message%completed=.FALSE.
+      message%pending=.TRUE.
+    ELSE
+      message%completed=.TRUE.
+      message%pending=.FALSE.
+    ENDIF
+!$OMP END MASTER
+!$OMP BARRIER
+     
     IF (field(1)%data_type==type_real) THEN
       IF (field(1)%ndim==2) THEN
 
-!$OMP MASTER
-        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
-!$OMP END MASTER
-!$OMP BARRIER
-
-        ireq=0        
         DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
+          
           rval2d=>field(ind)%rval2d
+        
           req=>message%request(ind)
-
           DO isend=1,req%nsend
-            ireq=ireq+1
-          ENDDO
-     
-          DO irecv=1,req%nrecv
-            ireq=ireq+1
-            recv=>req%recv(irecv)
-            IF (recv%rank/=mpi_rank .OR. .TRUE.) THEN
-              buffer_r2=>message%buffers(ireq)%r2
-              value=>recv%value
-              sgn=>recv%sign
-
-              CALL trace_in
+            send=>req%send(isend)
+            value=>send%value
+
             
-!$OMP DO SCHEDULE(STATIC)
-              DO n=1,recv%size
-                rval2d(value(n))=buffer_r2(n)*sgn(n)  
-              ENDDO        
-
-              CALL trace_out
+            IF (send%rank/=mpi_rank) THEN
+              ireq=send%ireq
+
+              buffer_r=>message%buffers(ireq)%r
+              offset=send%offset
+                                            
+              DO n=1,send%size
+                buffer_r(offset+n)=rval2d(value(n))
+              ENDDO
+
+              IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+                !$OMP CRITICAL            
+                CALL MPI_ISEND(buffer_r,send%size,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                !$OMP END CRITICAL
+              ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                CALL MPI_ISEND(buffer_r,send%size,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+              ENDIF
+             
             ENDIF
           ENDDO
-        
-        ENDDO
-      
+        ENDDO
+        
+        DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
+          rval2d=>field(ind)%rval2d
+          req=>message%request(ind)        
+
+          DO irecv=1,req%nrecv
+            recv=>req%recv(irecv)
+
+            IF (recv%rank==mpi_rank) THEN
+
+              value=>recv%value
+              src_value => recv%src_value
+              src_rval2d=>field(recv%domain)%rval2d
+              sgn=>recv%sign
+
+              DO n=1,recv%size
+                rval2d(value(n))=src_rval2d(src_value(n))*sgn(n)
+              ENDDO
+                
+                    
+            ELSE
+            
+              ireq=recv%ireq
+              buffer_r=>message%buffers(ireq)%r
+              IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+               !$OMP CRITICAL            
+                CALL MPI_IRECV(buffer_r,recv%size,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+               !$OMP END CRITICAL
+              ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                 CALL MPI_IRECV(buffer_r,recv%size,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+              ENDIF
+            
+            ENDIF
+          ENDDO
+        
+        ENDDO
+        
       
       ELSE  IF (field(1)%ndim==3) THEN
-
-!$OMP MASTER
-        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
-!$OMP END MASTER
-!$OMP BARRIER
-
-        ireq=0        
+      
         DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
+
+          dim3=size(field(ind)%rval3d,2)
           rval3d=>field(ind)%rval3d
           req=>message%request(ind)
-
+ 
           DO isend=1,req%nsend
-            ireq=ireq+1
-          ENDDO
-        
-          DO irecv=1,req%nrecv
-            ireq=ireq+1
-            recv=>req%recv(irecv)
-            IF (recv%rank/=mpi_rank .OR. .TRUE.) THEN
-              buffer_r3=>message%buffers(ireq)%r3
-              value=>recv%value
-              sgn=>recv%sign
-
-              CALL trace_in
-            
-!$OMP DO SCHEDULE(STATIC)
-              DO n=1,recv%size
-                rval3d(value(n),:)=buffer_r3(n,:)*sgn(n)  
-              ENDDO  
-
-              CALL trace_out
+            send=>req%send(isend)
+            value=>send%value
+
+            IF (send%rank/=mpi_rank) THEN
+              ireq=send%ireq
+              buffer_r=>message%buffers(ireq)%r
+              offset=send%offset*dim3
+
+              DO d3=1,dim3
+                DO n=1,send%size
+                  buffer_r(n+offset)=rval3d(value(n),d3)
+                ENDDO
+                offset=offset+send%size
+              ENDDO
+
+              IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+                !$OMP CRITICAL   
+                CALL MPI_ISEND(buffer_r,send%size*dim3,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                !$OMP END CRITICAL
+              ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                CALL MPI_ISEND(buffer_r,send%size*dim3,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+              ENDIF
             ENDIF
           ENDDO
+        ENDDO
+         
+        DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
+          dim3=size(field(ind)%rval3d,2)
+          rval3d=>field(ind)%rval3d
+          req=>message%request(ind)
+
+          DO irecv=1,req%nrecv
+            recv=>req%recv(irecv)
+
+            IF (recv%rank==mpi_rank) THEN
+              value=>recv%value
+              src_value => recv%src_value
+              src_rval3d=>field(recv%domain)%rval3d
+              sgn=>recv%sign
+
+              DO n=1,recv%size
+                rval3d(value(n),:)=src_rval3d(src_value(n),:)*sgn(n)
+              ENDDO
+
+            ELSE
+              ireq=recv%ireq
+              buffer_r=>message%buffers(ireq)%r
+ 
+              IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+                !$OMP CRITICAL
+                CALL MPI_IRECV(buffer_r,recv%size*dim3,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                !$OMP END CRITICAL
+              ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                CALL MPI_IRECV(buffer_r,recv%size*dim3,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+              ENDIF
+            ENDIF
+          ENDDO
         
         ENDDO
 
       ELSE  IF (field(1)%ndim==4) THEN
-!$OMP MASTER
-        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
-!$OMP END MASTER
-!$OMP BARRIER
-
-        ireq=0        
+    
         DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
+
+          dim3=size(field(ind)%rval4d,2)
+          dim4=size(field(ind)%rval4d,3)
           rval4d=>field(ind)%rval4d
           req=>message%request(ind)
 
           DO isend=1,req%nsend
-            ireq=ireq+1
-          ENDDO
-        
-          DO irecv=1,req%nrecv
-            ireq=ireq+1
-            recv=>req%recv(irecv)
-            IF (recv%rank/=mpi_rank .OR. .TRUE.) THEN
-              buffer_r4=>message%buffers(ireq)%r4
-              value=>recv%value
-              sgn=>recv%sign
-
-              CALL trace_in
-
-!$OMP DO SCHEDULE(STATIC)
-              DO n=1,recv%size
-                rval4d(value(n),:,:)=buffer_r4(n,:,:)*sgn(n) 
+            send=>req%send(isend)
+            value=>send%value
+
+            IF (send%rank/=mpi_rank) THEN
+
+              ireq=send%ireq
+              buffer_r=>message%buffers(ireq)%r
+              offset=send%offset*dim3*dim4
+
+              DO d4=1,dim4
+                DO d3=1,dim3
+                  DO n=1,send%size
+                    buffer_r(n+offset)=rval4d(value(n),d3,d4)
+                  ENDDO
+                  offset=offset+send%size
+                ENDDO
               ENDDO
 
-              CALL trace_out
+              IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+                !$OMP CRITICAL
+                CALL MPI_ISEND(buffer_r,send%size*dim3*dim4,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                !$OMP END CRITICAL
+              ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                CALL MPI_ISEND(buffer_r,send%size*dim3*dim4,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+              ENDIF
+
             ENDIF
           ENDDO
-        
-        ENDDO
-      
+        ENDDO
+        
+        DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
+          
+          dim3=size(field(ind)%rval4d,2)
+          dim4=size(field(ind)%rval4d,3)
+          rval4d=>field(ind)%rval4d
+          req=>message%request(ind)
+
+          DO irecv=1,req%nrecv
+            recv=>req%recv(irecv)
+            IF (recv%rank==mpi_rank) THEN
+              value=>recv%value
+              src_value => recv%src_value
+              src_rval4d=>field(recv%domain)%rval4d
+              sgn=>recv%sign
+
+              DO n=1,recv%size
+                rval4d(value(n),:,:)=src_rval4d(src_value(n),:,:)*sgn(n)
+              ENDDO
+                   
+            ELSE
+
+              ireq=recv%ireq
+              buffer_r=>message%buffers(ireq)%r
+              IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
+                !$OMP CRITICAL           
+                CALL MPI_IRECV(buffer_r,recv%size*dim3*dim4,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr) 
+                !$OMP END CRITICAL
+              ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
+                CALL MPI_IRECV(buffer_r,recv%size*dim3*dim4,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr) 
+              ENDIF
+    
+            ENDIF
+          ENDDO
+        ENDDO
+
       ENDIF      
-      
+
+      IF (mpi_threading_mode==MPI_THREAD_FUNNELED) THEN
+!$OMP BARRIER
+!$OMP MASTER        
+
+        DO ireq=1,message%nreq_send
+          buffer_r=>message%buffers(ireq)%r
+          msize=message%buffers(ireq)%size
+          rank=message%buffers(ireq)%rank
+          CALL MPI_ISEND(buffer_r,msize,MPI_REAL8,rank,1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+        ENDDO
+
+        DO ireq=message%nreq_send+1,message%nreq_send+message%nreq_recv
+          buffer_r=>message%buffers(ireq)%r
+          msize=message%buffers(ireq)%size
+          rank=message%buffers(ireq)%rank
+          CALL MPI_IRECV(buffer_r,msize,MPI_REAL8,rank,1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+        ENDDO
+
+!$OMP END MASTER
+      ENDIF              
     ENDIF
+    
+!$OMP BARRIER
+    CALL trace_end("transfert_mpi")
+    
+  END SUBROUTINE send_message_mpi
+  
+  SUBROUTINE test_message_mpi(message)
+  IMPLICIT NONE
+    TYPE(t_message) :: message
+    
+    INTEGER :: ierr
 
 !$OMP MASTER
-    message%pending=.FALSE.
+    IF (message%pending .AND. .NOT. message%completed) CALL MPI_TESTALL(message%nreq,message%mpi_req,message%completed,message%status,ierr)
 !$OMP END MASTER
-
-    CALL trace_end("transfert_mpi")
-!$OMP BARRIER
-    
-  END SUBROUTINE wait_message_mpi
-
-
-  SUBROUTINE transfert_request_mpi(field,request)
+  END SUBROUTINE  test_message_mpi
+  
+   
+  SUBROUTINE wait_message_mpi(message)
   USE field_mod
   USE domain_mod
   USE mpi_mod
   USE mpipara
+  USE omp_para
   USE trace
   IMPLICIT NONE
+    TYPE(t_message) :: message
+
     TYPE(t_field),POINTER :: field(:)
-    TYPE(t_request),POINTER :: request(:)
     REAL(rstd),POINTER :: rval2d(:) 
     REAL(rstd),POINTER :: rval3d(:,:) 
     REAL(rstd),POINTER :: rval4d(:,:,:) 
-    REAL(rstd),POINTER :: buffer_r2(:) 
-    REAL(rstd),POINTER :: buffer_r3(:,:) 
-    REAL(rstd),POINTER :: buffer_r4(:,:,:) 
+    REAL(rstd),POINTER :: buffer_r(:) 
     INTEGER,POINTER :: value(:) 
     INTEGER,POINTER :: sgn(:) 
@@ -1267,190 +1391,115 @@
     INTEGER :: irecv,isend
     INTEGER :: ireq,nreq
-    INTEGER :: ind,n
-    INTEGER :: dim3,dim4
+    INTEGER :: ind,n,l,m,i
+    INTEGER :: dim3,dim4,d3,d4
+    INTEGER :: offset
+
+    IF (.NOT. message%pending) RETURN
 
     CALL trace_start("transfert_mpi")
 
+    field=>message%field
+    nreq=message%nreq
+    
     IF (field(1)%data_type==type_real) THEN
       IF (field(1)%ndim==2) THEN
-      
-        nreq=sum(request(:)%nsend)+sum(request(:)%nrecv)
-        ALLOCATE(mpi_req(nreq))
-        ALLOCATE(status(MPI_STATUS_SIZE,nreq))
-    
-        ireq=0
+
+!$OMP MASTER
+        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
+!$OMP END MASTER
+!$OMP BARRIER
+        
         DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
+          
           rval2d=>field(ind)%rval2d
-        
-          req=>request(ind)
-          DO isend=1,req%nsend
-            send=>req%send(isend)
-
-            ALLOCATE(send%buffer_r2(send%size))
-            buffer_r2=>send%buffer_r2
-            value=>send%value
-            DO n=1,send%size
-              buffer_r2(n)=rval2d(value(n))
-            ENDDO
-
-            ireq=ireq+1
-            CALL MPI_ISEND(buffer_r2,send%size,MPI_REAL8,send%rank,ind,comm_icosa, mpi_req(ireq),ierr)
-          ENDDO
-        
+          req=>message%request(ind)
           DO irecv=1,req%nrecv
             recv=>req%recv(irecv)
-            ALLOCATE(recv%buffer_r2(recv%size))
-           
-            ireq=ireq+1
-            CALL MPI_IRECV(recv%buffer_r2,recv%size,MPI_REAL8,recv%rank,recv%domain,comm_icosa, mpi_req(ireq),ierr)
+            IF (recv%rank/=mpi_rank) THEN
+              ireq=recv%ireq
+              buffer_r=>message%buffers(ireq)%r
+              value=>recv%value
+              sgn=>recv%sign
+              offset=recv%offset
+              DO n=1,recv%size
+                rval2d(value(n))=buffer_r(n+offset)*sgn(n)  
+              ENDDO
+
+            ENDIF
           ENDDO
         
         ENDDO
-        
-        CALL MPI_WAITALL(nreq,mpi_req,status,ierr)
+      
+      
+      ELSE  IF (field(1)%ndim==3) THEN
+
+!$OMP MASTER
+        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
+!$OMP END MASTER
+!$OMP BARRIER
+
         
         DO ind=1,ndomain
-          rval2d=>field(ind)%rval2d
-        
-          req=>request(ind)
-          DO isend=1,req%nsend
-            send=>req%send(isend)
-            DEALLOCATE(send%buffer_r2)
-          ENDDO
-        
+          IF (.NOT. assigned_domain(ind)) CYCLE
+
+          rval3d=>field(ind)%rval3d
+          req=>message%request(ind)
           DO irecv=1,req%nrecv
             recv=>req%recv(irecv)
-            buffer_r2=>recv%buffer_r2
-            value=>recv%value
-            sgn=>recv%sign
-            DO n=1,recv%size
-              rval2d(value(n))=buffer_r2(n)*sgn(n)  
-            ENDDO        
-            DEALLOCATE(recv%buffer_r2)
+            IF (recv%rank/=mpi_rank) THEN
+              ireq=recv%ireq
+              buffer_r=>message%buffers(ireq)%r
+              value=>recv%value
+              sgn=>recv%sign
+              
+              dim3=size(rval3d,2)
+              offset=recv%offset*dim3
+              DO d3=1,dim3
+                DO n=1,recv%size
+                  rval3d(value(n),d3)=buffer_r(n+offset)*sgn(n)  
+                ENDDO
+                offset=offset+recv%size
+              ENDDO  
+            ENDIF
           ENDDO
         
         ENDDO
-      
-      
-      ELSE  IF (field(1)%ndim==3) THEN
-      
-        nreq=sum(request(:)%nsend)+sum(request(:)%nrecv)
-        ALLOCATE(mpi_req(nreq))
-        ALLOCATE(status(MPI_STATUS_SIZE,nreq))
-    
-        ireq=0
+
+      ELSE  IF (field(1)%ndim==4) THEN
+!$OMP MASTER
+        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
+!$OMP END MASTER
+!$OMP BARRIER
+
+                
         DO ind=1,ndomain
-          dim3=size(field(ind)%rval3d,2)
-          rval3d=>field(ind)%rval3d
-        
-          req=>request(ind)
-          DO isend=1,req%nsend
-            send=>req%send(isend)
-
-            ALLOCATE(send%buffer_r3(send%size,dim3))
-            buffer_r3=>send%buffer_r3
-            value=>send%value
-            DO n=1,send%size
-              buffer_r3(n,:)=rval3d(value(n),:)
-            ENDDO
-
-            ireq=ireq+1
-            CALL MPI_ISEND(buffer_r3,send%size*dim3,MPI_REAL8,send%rank,ind,comm_icosa, mpi_req(ireq),ierr)
-          ENDDO
-        
+          IF (.NOT. assigned_domain(ind)) CYCLE
+
+          rval4d=>field(ind)%rval4d
+          req=>message%request(ind)
           DO irecv=1,req%nrecv
             recv=>req%recv(irecv)
-            ALLOCATE(recv%buffer_r3(recv%size,dim3))
-           
-            ireq=ireq+1
-            CALL MPI_IRECV(recv%buffer_r3,recv%size*dim3,MPI_REAL8,recv%rank,recv%domain,comm_icosa, mpi_req(ireq),ierr)
+            IF (recv%rank/=mpi_rank) THEN
+              ireq=recv%ireq
+              buffer_r=>message%buffers(ireq)%r
+              value=>recv%value
+              sgn=>recv%sign
+
+              dim3=size(rval4d,2)
+              dim4=size(rval4d,3)
+              offset=recv%offset*dim3*dim4
+              DO d4=1,dim4
+                DO d3=1,dim3
+                  DO n=1,recv%size
+                    rval4d(value(n),d3,d4)=buffer_r(n+offset)*sgn(n) 
+                  ENDDO
+                  offset=offset+recv%size
+                ENDDO
+              ENDDO
+            ENDIF
           ENDDO
         
         ENDDO
-        
-        CALL MPI_WAITALL(nreq,mpi_req,status,ierr)
-        
-        DO ind=1,ndomain
-          rval3d=>field(ind)%rval3d
-        
-          req=>request(ind)
-          DO isend=1,req%nsend
-            send=>req%send(isend)
-            DEALLOCATE(send%buffer_r3)
-          ENDDO
-        
-          DO irecv=1,req%nrecv
-            recv=>req%recv(irecv)
-            buffer_r3=>recv%buffer_r3
-            value=>recv%value
-            sgn=>recv%sign
-            DO n=1,recv%size
-              rval3d(value(n),:)=buffer_r3(n,:)*sgn(n)  
-            ENDDO        
-            DEALLOCATE(recv%buffer_r3)
-          ENDDO
-        
-        ENDDO
-
-      ELSE  IF (field(1)%ndim==4) THEN
-      
-        nreq=sum(request(:)%nsend)+sum(request(:)%nrecv)
-        ALLOCATE(mpi_req(nreq))
-        ALLOCATE(status(MPI_STATUS_SIZE,nreq))
-    
-        ireq=0
-        DO ind=1,ndomain
-          dim3=size(field(ind)%rval4d,2)
-          dim4=size(field(ind)%rval4d,3)
-          rval4d=>field(ind)%rval4d
-        
-          req=>request(ind)
-          DO isend=1,req%nsend
-            send=>req%send(isend)
-
-            ALLOCATE(send%buffer_r4(send%size,dim3,dim4))
-            buffer_r4=>send%buffer_r4
-            value=>send%value
-            DO n=1,send%size
-              buffer_r4(n,:,:)=rval4d(value(n),:,:)
-            ENDDO
-
-            ireq=ireq+1
-            CALL MPI_ISEND(buffer_r4,send%size*dim3*dim4,MPI_REAL8,send%rank,ind,comm_icosa, mpi_req(ireq),ierr)
-          ENDDO
-        
-          DO irecv=1,req%nrecv
-            recv=>req%recv(irecv)
-            ALLOCATE(recv%buffer_r4(recv%size,dim3,dim4))
-           
-            ireq=ireq+1
-            CALL MPI_IRECV(recv%buffer_r4,recv%size*dim3*dim4,MPI_REAL8,recv%rank,recv%domain,comm_icosa, mpi_req(ireq),ierr)
-          ENDDO
-        
-        ENDDO
-        
-        CALL MPI_WAITALL(nreq,mpi_req,status,ierr)
-        
-        DO ind=1,ndomain
-          rval4d=>field(ind)%rval4d
-        
-          req=>request(ind)
-          DO isend=1,req%nsend
-            send=>req%send(isend)
-            DEALLOCATE(send%buffer_r4)
-          ENDDO
-        
-          DO irecv=1,req%nrecv
-            recv=>req%recv(irecv)
-            buffer_r4=>recv%buffer_r4
-            value=>recv%value
-            sgn=>recv%sign
-            DO n=1,recv%size
-              rval4d(value(n),:,:)=buffer_r4(n,:,:)*sgn(n) 
-            ENDDO        
-            DEALLOCATE(recv%buffer_r4)
-          ENDDO
-        
-        ENDDO
       
       ENDIF      
@@ -1458,7 +1507,29 @@
     ENDIF
 
+!$OMP MASTER
+    message%pending=.FALSE.
+!$OMP END MASTER
+
     CALL trace_end("transfert_mpi")
-    
+!$OMP BARRIER
+    
+  END SUBROUTINE wait_message_mpi
+
+  SUBROUTINE transfert_request_mpi(field,request)
+  USE field_mod
+  IMPLICIT NONE
+    TYPE(t_field),POINTER :: field(:)
+    TYPE(t_request),POINTER :: request(:)
+
+    TYPE(t_message),SAVE :: message
+   
+   
+    CALL init_message_mpi(field,request, message)
+    CALL transfert_message_mpi(field,message)
+    CALL finalize_message_mpi(field,message)
+   
   END SUBROUTINE transfert_request_mpi
+ 
+   
    
   SUBROUTINE transfert_request_seq(field,request)
